interface Config<T> {
    disable?: boolean;
    prefixes?: string[];
    test?: (...args: any[]) => boolean;
    api?: T;
}
type LoggerFunction = (...args: any[]) => void;
type FormatterFunction = (...args: any[]) => any;
export declare function autowire(customFormatter?: FormatterFunction): (originalFunc: LoggerFunction, { kind, name }: {
    kind: string;
    name: string;
}) => LoggerFunction | void;
export declare class Logger<T = Console> {
    config: Config<T | Console>;
    constructor(config?: Config<T>);
    get api(): T;
    allowed(...args: any[]): boolean;
}
export declare class ConsoleLogger extends Logger<Console> {
    constructor(config: Omit<Config<Console>, 'api'>);
    log(): void;
    warn(): void;
    debug(): void;
    error(): void;
    info(): void;
}
export declare const logger: ConsoleLogger;
export {};
//# sourceMappingURL=index.d.ts.map